Xapian: API Documentation: Xapian::BM25Weight Class Reference

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
Xapian::BM25Weight Class Reference

Xapian::Weight subclass implementing the BM25 probabilistic formula. More...

Inheritance diagram for Xapian::BM25Weight:
[legend]

## Public Member Functions
| BM25Weight (double k1, double k2, double k3, double b, double min_normlen)
| Construct a BM25Weight. More...
std::string | name () const
| Return the name of this weighting scheme. More...
std::string | serialise () const
| Return this object's parameters serialised as a single string. More...
BM25Weight * | unserialise (const std::string &s) const
| Unserialise parameters. More...
Xapian::weight | get_sumpart (Xapian::termcount wdf, Xapian::termcount doclen) const
| Calculate the weight contribution for this object's term to a document. More...
Xapian::weight | get_maxpart () const
| Return an upper bound on what get_sumpart() can return for any document. More...
Xapian::weight | get_sumextra (Xapian::termcount doclen) const
| Calculate the term-independent weight component for a document. More...
Xapian::weight | get_maxextra () const
| Return an upper bound on what get_sumextra() can return for any document. More...
Public Member Functions inherited from Xapian::Weight
virtual | ~Weight ()
| Virtual destructor, because we have virtual methods. More...

## Additional Inherited Members
Protected Types inherited from Xapian::Weight
enum | stat_flags
| Stats which the weighting scheme can use (see need_stat()).
Protected Member Functions inherited from Xapian::Weight
void | need_stat (stat_flags flag)
| Tell Xapian that your subclass will want a particular statistic. More...
| Weight (const Weight &)
| Don't allow copying. More...
| Weight ()
| Default constructor, needed by subclass constructors.
Xapian::doccount | get_collection_size () const
| The number of documents in the collection.
Xapian::doccount | get_rset_size () const
| The number of documents marked as relevant.
Xapian::doclength | get_average_length () const
| The average length of a document in the collection.
Xapian::doccount | get_termfreq () const
| The number of documents which this term indexes.
Xapian::doccount | get_reltermfreq () const
| The number of relevant documents which this term indexes.
Xapian::termcount | get_query_length () const
| The length of the query.
Xapian::termcount | get_wqf () const
| The within-query-frequency of this term.
Xapian::termcount | get_doclength_upper_bound () const
| An upper bound on the maximum length of any document in the database. More...
Xapian::termcount | get_doclength_lower_bound () const
| A lower bound on the minimum length of any document in the database. More...
Xapian::termcount | get_wdf_upper_bound () const
| An upper bound on the wdf of this term. More...

## Detailed Description

Xapian::Weight subclass implementing the BM25 probabilistic formula.

## Constructor & Destructor Documentation

Xapian::BM25Weight::BM25Weight | ( | double | k1,
|  | double | k2,
|  | double | k3,
|  | double | b,
|  | double | min_normlen
| ) |  |
| inline

Construct a BM25Weight.

Parameters

  k1 | A non-negative parameter controlling how influential within-document-frequency (wdf) is. k1=0 means that wdf doesn't affect the weights. The larger k1 is, the more wdf influences the weights. (default 1)
  k2 | A non-negative parameter which controls the strength of a correction factor which depends upon query length and normalised document length. k2=0 disable this factor; larger k2 makes it stronger. (default 0)
  k3 | A non-negative parameter controlling how influential within-query-frequency (wqf) is. k3=0 means that wqf doesn't affect the weights. The larger k3 is, the more wqf influences the weights. (default 1)
  b | A parameter between 0 and 1, controlling how strong the document length normalisation of wdf is. 0 means no normalisation; 1 means full normalisation. (default 0.5)
  min_normlen | A parameter specifying a minimum value for normalised document length. Normalised document length values less than this will be clamped to this value, helping to prevent very short documents getting large weights. (default 0.5)

## Member Function Documentation

Xapian::weight Xapian::BM25Weight::get_maxextra | ( |  | ) | const
| virtual

Return an upper bound on what get_sumextra() can return for any document.

This information is used by the matcher to perform various optimisations, so strive to make the bound as tight as possible.

Implements Xapian::Weight.

Xapian::weight Xapian::BM25Weight::get_maxpart | ( |  | ) | const
| virtual

Return an upper bound on what get_sumpart() can return for any document.

This information is used by the matcher to perform various optimisations, so strive to make the bound as tight as possible.

Implements Xapian::Weight.

Xapian::weight Xapian::BM25Weight::get_sumextra | ( | Xapian::termcount | doclen | ) | const
| virtual

Calculate the term-independent weight component for a document.

The parameter gives information about the document which may be used in the calculations:

Parameters

  doclen | The document's length (unnormalised).

Implements Xapian::Weight.

Xapian::weight Xapian::BM25Weight::get_sumpart | ( | Xapian::termcount | wdf,
|  | Xapian::termcount | doclen
| ) |  | const
| virtual

Calculate the weight contribution for this object's term to a document.

The parameters give information about the document which may be used in the calculations:

Parameters

  wdf | The within document frequency of the term in the document.
  doclen | The document's length (unnormalised).

Implements Xapian::Weight.

std::string Xapian::BM25Weight::name | ( |  | ) | const
| virtual

Return the name of this weighting scheme.

This name is used by the remote backend. It is passed along with the serialised parameters to the remote server so that it knows which class to create.

Return the full namespace-qualified name of your class here - if your class is called FooWeight, return "FooWeight" from this method (Xapian::BM25Weight returns "Xapian::BM25Weight" here).

If you don't want to support the remote backend, you can use the default implementation which simply returns an empty string.

Reimplemented from Xapian::Weight.

std::string Xapian::BM25Weight::serialise | ( |  | ) | const
| virtual

Return this object's parameters serialised as a single string.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Reimplemented from Xapian::Weight.

BM25Weight* Xapian::BM25Weight::unserialise | ( | const std::string & | s | ) | const
| virtual

Unserialise parameters.

This method unserialises parameters serialised by the serialise() method and allocates and returns a new object initialised with them.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: http://trac.xapian.org/ticket/554#comment:1

Parameters

  s | A string containing the serialised parameters.

Reimplemented from Xapian::Weight.

The documentation for this class was generated from the following file:

- xapian/weight.h